datablock ShapeBaseImageData(DangerStateObjectImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = true;
  mountPoint = $HeadSlot;
  offset = "0 0 0";
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  eyeRotation = eulerToMatrix("0 0 0");
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
  hasLight = false;
  doRetraction = false;

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Idle";

  stateName[1] = "Idle";
  stateSound[1] = CINEMATIC_DangerState;
};

function DangerStateObjectImage::onMount(%this,%obj)
{
	%this.schedule(100,DangerStateImpulse,%obj);
	%obj.inclineHeartbeat = true;
	%obj.percent = 0;
}
function DangerStateObjectImage::onUnMount(%this, %obj)
{
	commandToClient( %obj.client, 'SetVignette', $EnvGuiServer::VignetteMultiply, $EnvGuiServer::VignetteColor );
	cancel(%this.ImpulseSched);
}
function DangerStateObjectImage::DangerStateImpulse(%this,%obj)
{
	cancel(%this.ImpulseSched);

	if(%obj.getState() $= "Dead")
	{
		%obj.isInDangerState = false;
		%obj.hasStartedDangerSounds = false;
		%obj.schedule(100, unmountImage, 1);
		return;
	}

	%obj.addhealth(-0.075);

	%damageInfluence = 0.1 * ((%obj.getDamageLevel() / 10) - 4);

	if(%obj.inclineHeartbeat)
	{
		%obj.percent = %obj.percent + 0.2;
		commandToClient( %obj.client, 'SetVignette', true, "1 0 0" SPC %obj.percent);
		if(%obj.percent >= 1)
		{
			%obj.inclineHeartbeat = false;
		}
	}
	else
	{
		%obj.percent = %obj.percent - 0.2;
		commandToClient( %obj.client, 'SetVignette', true, "1 0 0" SPC %obj.percent);
		if(%obj.percent <= 0.5)
		{
			%obj.inclineHeartbeat = true;
		}
	}

	%obj.spawnExplosion(cinematicImpulseProjectile,%damageInfluence SPC %damageInfluence SPC %damageInfluence);

	%this.ImpulseSched = %this.schedule(100,DangerStateImpulse,%obj);
}
